/* -------------------------------------------
   Definition of classes in C++
   Constructors
   -------------------------------------------
*/
   

#include <iostream>
#include <cmath>

using namespace std;

class line {                    // *** Start of class declaration
public:                         // "public" means that everything is visible from outside    
    // Fields declaration
    float x1, y1, x2, y2;
    float len;
    
    // Method to calculate the length
    void linelen() {         
        len=sqrt(pow((x1-x2),2)+pow((y1-y2),2));
    }
    // Constructor 1: all four coordinates are given
    line(float px1, float py1, float px2, float py2) {
        x1=px1;
        y1=py1;
        x2=px2;
        y2=py2;
        linelen();
    }
    // Constructor 2: point 1 coordinates ASSUMED to be (0,0), 
    //                point 2 coordinates are given
    line(float px2, float py2) {
        x1=0;   
        y1=0;
        x2=px2;
        y2=py2;
        linelen();
    }
    // Constructor 3: No coordinates are given. 
    //                Will be read from the console
    line() {
        cout<<endl<<"New line"<<endl;
        cout<<"X1:"; cin>>x1;
        cout<<"Y1:"; cin>>y1;
        cout<<"X2:"; cin>>x2;
        cout<<"Y2:"; cin>>y2;
        linelen();
    }
}; // *** End of class declaration



int main()
{
    line l1(0,0,1,1);
    line l2(2,2);
    
    cout<<"Welcome to oo programming"<<endl;
    
    cout<<"Line 1 has length equal to "<<l1.len<<endl;
    
    cout<<"Line 2 has length equal to "<<l2.len<<endl;
    
    line l3;
    cout<<"Line 3 has length equal to "<<l3.len<<endl;
    
    system("pause");
    return 0;
}   
